unit PRTskChng_IMPL;

interface

uses
  ComObj, ComServ, ActiveX, Variants, adxAddIn, PRTskChng_TLB, StdVcl,
  Project2000, Dialogs;

type
  TTADXPRAddin = class(TadxAddin, ITADXPRAddin)
  end;

  TAddInModule = class(TadxCOMAddInModule)
    procedure adxCOMAddInModuleAddInInitialize(Sender: TObject);
    procedure adxCOMAddInModuleAddInFinalize(Sender: TObject);
  private
    procedure DoTaskChange(Sender: TObject; var tsk: OleVariant; Field: PjField;
      NewVal: OleVariant; var Cancel: OleVariant);
  end;

implementation

{$R *.dfm}

{ TAddInModule }

procedure TAddInModule.DoTaskChange(Sender: TObject; var tsk: OleVariant;
  Field: PjField; NewVal: OleVariant; var Cancel: OleVariant);
begin
  Cancel := True;
  ShowMessage('The changes are canceled.');
end;

procedure TAddInModule.adxCOMAddInModuleAddInInitialize(Sender: TObject);
begin
  ProjectApp.OnProjectBeforeTaskChange := DoTaskChange;
end;

procedure TAddInModule.adxCOMAddInModuleAddInFinalize(Sender: TObject);
begin
  ProjectApp.OnProjectBeforeTaskChange := nil;
end;

initialization
  TadxFactory.Create(ComServer, TTADXPRAddin, CLASS_TADXPRAddin, TAddInModule);

end.
